// GameChuck - Lights
// Josh Villbrandt (http://javconcepts.com/)
// July 30, 2010

#define light0base 40
#define light1base 47
#define on HIGH
#define off LOW

void sevenseg(int light, int number) {
  if(light >= 0 && light <= 1) {
    int lightbase = light0base;
    if(light == 1) lightbase = light1base;
    
    if(number < 0) light_off(lightbase);
    else if(number  == 0) light_zero(lightbase);
    else if(number  == 1) light_one(lightbase);
    else if(number  == 2) light_two(lightbase);
    else if(number  == 3) light_three(lightbase);
    else if(number  == 4) light_four(lightbase);
    else if(number  == 5) light_five(lightbase);
    else if(number  == 6) light_six(lightbase);
    else if(number  == 7) light_seven(lightbase);
    else if(number  == 8) light_eight(lightbase);
    else if(number  == 9) light_nine(lightbase);
  }
}

void light_off(int lightbase) {
  pinMode(lightbase, off);
  pinMode(lightbase + 1, off);
  pinMode(lightbase + 2, off);
  pinMode(lightbase + 3, off);
  pinMode(lightbase + 4, off);
  pinMode(lightbase + 5, off);
  pinMode(lightbase + 6, off);
}

void light_zero(int lightbase) {
  pinMode(lightbase, off);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, on);
}

void light_one(int lightbase) {
  pinMode(lightbase, off);
  pinMode(lightbase + 1, off);
  pinMode(lightbase + 2, off);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, off);
  pinMode(lightbase + 6, off);
}

void light_two(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, off);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, off);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, on);
}

void light_three(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, off);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, off);
}

void light_four(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, off);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, off);
  pinMode(lightbase + 6, off);
}

void light_five(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, off);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, off);
}

void light_six(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, off);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, on);
}

void light_seven(int lightbase) {
  pinMode(lightbase, off);
  pinMode(lightbase + 1, off);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, off);
  pinMode(lightbase + 6, off);
}

void light_eight(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, on);
  pinMode(lightbase + 6, on);
}

void light_nine(int lightbase) {
  pinMode(lightbase, on);
  pinMode(lightbase + 1, on);
  pinMode(lightbase + 2, on);
  pinMode(lightbase + 3, on);
  pinMode(lightbase + 4, on);
  pinMode(lightbase + 5, off);
  pinMode(lightbase + 6, off);
}

void sevenseg_spin(int rate, int times) {
  for(int i = 0; i < times; i++) {
    for(int j = 1; j < 7; j++) {
      // turn new lights on
      pinMode(light0base + j, on);
      pinMode(light1base + j, on);
      
      // turn old ones off
      if(j == 1) {
        pinMode(light0base + 6, off);
        pinMode(light1base + 6, off);
      }
      else {
        pinMode(light0base + j - 1, off);
        pinMode(light1base + j - 1, off);
      }
      delay(rate);
    }
  }
  
  // cleanup? naw...
}

void sevenseg_score(int score) {
  int temp = score / 10;
  int digit1 = score - 10*temp;
  score = temp;
  temp = score / 10;
  int digit0 = score - 10*temp;
  
  sevenseg(0, digit0);
  sevenseg(1, digit1);
}
